/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧ق͑eʋLƂǗ܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: ATmega32U4
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "conf_access.h"
#include "lib_mcu/timer/timer8_drv.h"
#include "lib_mcu/adc/adc_drv.h"
#include "lib_board/evk_527/evk_527.h"
#include "modules/usb/device_chap9/usb_standard_request.h"
#include "modules/control_access/ctrl_access.h"
#include "modules/file_system/navigation.h"
#include "modules/file_system/file.h"
#include "datalogging_task.h"
#include "stdio.h"

//_____ ϸ ________________________________________________________________

//#define LOG_ADCMIC_EXAMPLE				// (ADCWav̧) ϲ̫݂قL^(:̋@\͗p\łAEVK527zuSPI()ϲ̫ݐ邽߁AiłB)
//#define LOG_ADCEXT_EXAMPLE				// (ADCBiņ) OقL^
//#define LOG_PIN_EXAMPLE					// (ݏԁBiņ) ݏԂL^
#define LOG_ENUM_EXAMPLE					// (ԍ񋓁Biņ) ш搧邱ƂB

//_____ ` _______________________________________________________________

//! ɏՕǗ
#define NB_DATA_BUF				2
#define DATA_BUF_SIZE			(NB_DATA_BUF*FS_SIZE_OF_SECTOR)
// ̧ي蓖ċ(512޲ P)
#define FILE_ALLOC_SIZE			((1024L*1024L)/512L)	// 1M޲
#define FILE_ALLOC_SIZE_MIN		((100*1024L)/512L)		// 100K޲

//_____ 錾 _______________________________________________________________

Bool g_b_datalogging_running;
U16  g_u16_buf_pos_wr;						// (volatile̕Kv͂܂B)
U8   g_u8_cur_buf;							// ݂̊ɏՕ҂(volatile̕Kv͂܂B)
U8   g_u8_cur_buf_wr;						// ݂̊ɏՕ҂(volatile̕Kv͂܂B)
Bool g_b_buf_full[NB_DATA_BUF];				// ɏՕ̏Ԃ}(volatile̕Kv͂܂B)
U8   g_data_buf[DATA_BUF_SIZE];

Bool datalogging_start                  (void);
void datalogging_stop                   (void);
Bool datalogging_open_disk              (void);
Bool datalogging_create_path_file       (void);
Bool datalogging_create_file            (void);
Bool datalogging_alloc_file_space       (void);
Bool datalogging_file_write_sector      (void);
Bool datalogging_file_write_all         (void);
void datalogging_file_init_wav_header   (void);
Bool datalogging_file_update_wav_header (void);
U16  datalogging_get_adc_ext_val        (void);

//! @brief ̊֐ްL^Ƃ܂B
//!
void datalogging_task_init(void)
{
	g_b_datalogging_running = FALSE;
	Led0_init();
	Led2_init();
	Joy_init();
	Hwb_button_init();
#if (LUN_2 == ENABLE)						// DataFlash
	df_mem_init();							// DataFlash쓮̂ɕKvʰ޳/ĳ̎
#endif
#if (LUN_3 == ENABLE)						// MMC/SD
	Mmc_init_spi();							// MMC/SD쓮̂ɕKvʰ޳/ĳ̎
#endif
}

//! @brief ްL^ƊǗ̓_
//!
void datalogging_task(void)
{
	// ްL^ԕύX
	if( Is_joy_down()						// gp҂ɂްL^Jnꂽꍇ
	   && (!Is_device_enumerated()))		// USBu삪~ꂽꍇ
	{
		if( !g_b_datalogging_running )
		{
			// ްL^Jn
			Led2_off();						// ُ׸މ
			nav_reset();					//** ̧ я
			g_b_datalogging_running = datalogging_start();
			if( g_b_datalogging_running )
			{
				Led0_on();
			}else{
				Led2_on();					// ްL^Jns
			}
		}
	}
	if( Is_hwb()							// gp҂ɂްL^~ꂽꍇ
	   || Is_device_enumerated() )			// ܂USBu삪Jnꂽꍇ
	{
		if( g_b_datalogging_running )
		{
			// ްL^~
			g_b_datalogging_running = FALSE;
			datalogging_stop();
			nav_exit();						//** ̧ ѕo
			Led0_off();
		}
	}

	// ްL^wʍƎs
	if( g_b_datalogging_running )
	{
		Led0_toggle();
		g_b_datalogging_running = datalogging_file_write_sector();
		if( !g_b_datalogging_running )
		{
			datalogging_stop();
			nav_exit();						//** ̧ ѕo
			Led2_on();						// ްݏɈُ
			Led0_off();
		}
	}
}

//! @brief ްL^Jn
//!
//! @return	ُ̏ꍇFALSE
//!
Bool datalogging_start(void)
{
	// ިJ
	if( !datalogging_open_disk() )
		return FALSE;
	// ٍ̧쐬
	if( !datalogging_create_path_file() )
		return FALSE;
	// ްL^ɑш𑝂߂ɸ׽ꗗ蓖
	if( datalogging_alloc_file_space() )
		return TRUE;						// ̧ق쐬FATԂ蓖Ă܂B

	// ɏՕ䏉
	for( g_u8_cur_buf=0; g_u8_cur_buf<NB_DATA_BUF; g_u8_cur_buf++) {
		g_b_buf_full[g_u8_cur_buf] = FALSE;
	}
	g_u8_cur_buf     = 0;
	g_u8_cur_buf_wr  = 0;
	g_u16_buf_pos_wr = 0;

#ifdef LOG_ADCMIC_EXAMPLE
	// ̧قɐ擪ްǉ
	datalogging_file_init_wav_header();
#endif

#ifdef LOG_ADCMIC_EXAMPLE
	// 125sɎ擾荞݊Jn
	Dac_micro_init();
	init_adc();
	Timer8_set_waveform_mode(TIMER8_WGM_CTC_OCR);	// /0CTC`Ԃ
	Timer8_set_clock(TIMER8_0_CLKIO_BY_8);			// 8MHz/8=1MHz
	Timer8_set_compare(125);						// 125v=125s
	Timer8_compare_it_enable();						// rv荞݋
#else
	// 110sɎ擾荞݊Jn
	Timer8_set_waveform_mode(TIMER8_WGM_CTC_OCR);	// /0CTC`Ԃ
	Timer8_set_clock(TIMER8_0_CLKIO_BY_8);			// 8MHz/8=1MHz
	Timer8_set_compare(110);						// 110v=110s~2޲=18K޲/s
	Timer8_compare_it_enable();						// rv荞݋
#endif
	return TRUE;
}

//! @brief ްL^~
//!
void datalogging_stop(void)
{
	// 擾荞ݒ~
	Timer8_compare_it_disable();

	// ̧ق
	datalogging_file_write_all();
#ifdef LOG_ADCMIC_EXAMPLE
	datalogging_file_update_wav_header();
#endif
	file_close();
}

//! @brief ިJ
//!
//! @return	ُ̏ꍇFALSE
//!
Bool datalogging_open_disk(void)
{
	U8 u8_i;
	nav_select(FS_NAV_ID_DEFAULT);

#if( (LUN_2 == ENABLE) && (LUN_3 == ENABLE))	// conf_access.hŐݒ肳`Ԑݒ
	// MMC/SD(LUN1)܂DataFlash(LUN0)ިIĐt݂
	// ŏMMC/SDs
	for( u8_i=1; u8_i!=0xFF; u8_i-- )
#else
	// There is only one memory MMC/SD܂DataFlash1؂B
	for( u8_i=0; u8_i!=0xFF; u8_i-- )
#endif
	{
		if( nav_drive_set(u8_i) )			// (ިł͂Ȃ)ײނI
		{
			// p\ײނ͂̌ɂ𐘕t
			if( !nav_partition_mount() )
			{
				// tɈُȂAُԌ
				if( FS_ERR_NO_FORMAT != fs_g_status )
					continue;				// ިs(s݁Aʰ޳ُAшُȂ)
				// ̫ϯ ިȂA̫ϯ
				if( !nav_drive_format(FS_FORMAT_DEFAULT) )
					continue;				// ̫ϯĎs
			}
			return TRUE;					// ިtς
		}
	}
	return FALSE;							// LިȂB
}

//! @brief ްL^i[邽߂߽쐬
//!
//! @return	ُ̏ꍇFALSE
//!
Bool datalogging_create_path_file(void)
{
	char ascii_name[15];
	U16 u16_dir_num = 0;

	if( !nav_dir_root() )
		return FALSE;						// ̧ шُ

	while( u16_dir_num < 30 )				// ިڸؐ̐͒PȂ
	{
		sprintf( ascii_name, "./log%03d/", u16_dir_num);

		// ިڸ؂ֈڍsĕs݂̏ꍇɌǂ쐬
		if( !nav_setcwd( ascii_name, FALSE, TRUE) )
			return FALSE;					// ̧ шُ

		// ٍ̧쐬
		if( datalogging_create_file() )
			return TRUE;					// ̧ق쐬܂B

		// ŁAިڸ؂tȂA̕ިڸ؂쐬邽߂ɐeިڸ؂֍sB
		if( !nav_dir_gotoparent() )
			return FALSE;					// ̧ шُ
		u16_dir_num++;
	}
	return FALSE;							// L^ިڸ؂̧ق
}

//! @brief ްL^i[邽߂̧ق쐬
//!
//! @return	ُ̏ꍇFALSE
//!
Bool datalogging_create_file(void)
{
	char ascii_name[15];
	U16 u16_file_num = 0;

	while( u16_file_num < 10 )
	{
		// ٍ̧쐬
#ifdef LOG_ADCMIC_EXAMPLE
		sprintf( ascii_name, "sound%03d.wav", u16_file_num);
#else
		sprintf( ascii_name, "log%03d.bin", u16_file_num);
#endif
		if( nav_file_create( ascii_name ))
			return TRUE;					// ŁA̧ق쐬AAċɂ܂B
		// 쐬ɈُȂAُ팟
		if( fs_g_status != FS_ERR_FILE_EXIST )
			return FALSE;					// ̧ шُ(ިtAިڸؖtȂ)
		// ّ̧݂ȂAO̔ԍ𑝉
		u16_file_num++;
	}
	return FALSE;							// ݂ިڸّ̧ؓ
}

//! @brief ްL^ɑш𑝂߂FATŸ׽ꗗ̧ق蓖
//!
//! @return	ُ̏ꍇFALSE
//!
Bool datalogging_alloc_file_space(void)
{
	Fs_file_segment g_recorder_seg;

	// ݓō쐬ꂽ̧قJ
	if( !file_open(FOPEN_MODE_W))
		return FALSE;

	// 蓖Ă邽߂̾Ă̑傫`(512޲ĒP)
	// :v̑傫mȂꍇɂƊ蓖Ă邱Ƃł܂B
	g_recorder_seg.u16_size = FILE_ALLOC_SIZE;

	// FATžėeʂƓ܂͈ȉ̸׽ꗗ蓖
	if( !file_write( &g_recorder_seg ))
	{
		file_close();
		return FALSE;
	}

	// ]ނȂA蓖Ăꂽŏeʂ𒲂ׂ邱Ƃł܂B
	if( g_recorder_seg.u16_size < FILE_ALLOC_SIZE_MIN )
	{
		file_close();
		nav_file_del(FALSE);
		return FALSE;
	}

	// 傫ؾĂ邽߂ɊJ/
	// :̎菇͐sFAT蓖Ă폜܂B
	file_close();							// ̧ق
	if( !file_open(FOPEN_MODE_W))			// ݓ̧قJđ傫0ɋ
		return FALSE;
	return TRUE;							//** ̧قJFAT蓖Ă܂B
}

//! @brief ̧قɗp\ΊɏՕi[
//!
//! @return	ُ̏ꍇFALSE
//!
Bool datalogging_file_write_sector(void)
{
	// !!!! :
	// ꂽɏՕ̑傫512޲Ă̔{ŁA̧݂وʒu512޲Ă̔{
	// A"file_write_buf()"ٰ݂ɌIłB
	if( g_b_buf_full[g_u8_cur_buf] )
	{
		if( !file_write_buf( &g_data_buf[g_u8_cur_buf*FS_SIZE_OF_SECTOR], FS_SIZE_OF_SECTOR ) )
			return FALSE;					// ُ݈
		g_b_buf_full[g_u8_cur_buf] = FALSE;
		// VɏՕ҂
		g_u8_cur_buf++;
		if( NB_DATA_BUF == g_u8_cur_buf )
			g_u8_cur_buf = 0;
	}
	return TRUE;
}

//! @brief ̧قɗp\ȊɏՕi[
//!
//! @return	ُ̏ꍇFALSE
//!
Bool datalogging_file_write_all(void)
{
	// ɏՕ
	while( g_b_buf_full[g_u8_cur_buf] ) {
		if( !datalogging_file_write_sector())
			return FALSE;					// ިłُ̈
	}
	// cް
	if( g_u16_buf_pos_wr != (g_u8_cur_buf*FS_SIZE_OF_SECTOR) )
	{
		if( !file_write_buf( &g_data_buf[g_u8_cur_buf*FS_SIZE_OF_SECTOR], g_u16_buf_pos_wr-(g_u8_cur_buf*FS_SIZE_OF_SECTOR) ) )
			return FALSE;					// ُ݈
	}
	return TRUE;
}

#ifdef LOG_ADCMIC_EXAMPLE
//! @brief WAV擪ُ̧
//!
void datalogging_file_init_wav_header(void)
{
	// ɏՕWAV擪̧ق

	// ݸID̈			(0-3)
	g_data_buf[ 0]='R';
	g_data_buf[ 1]='I';
	g_data_buf[ 2]='F';
	g_data_buf[ 3]='F';
	// ݸeʗ̈			(4-7) - L^~ɍXV
	// ̫ϯė̈			(8-11)
	g_data_buf[ 8]='W';
	g_data_buf[ 9]='A';
	g_data_buf[10]='V';
	g_data_buf[11]='E';
	// ݸ1ID̈		(12-15)
	g_data_buf[12]='f';
	g_data_buf[13]='m';
	g_data_buf[14]='t';
	g_data_buf[15]=' ';
	// ݸ1eʗ̈		(16-19)
	g_data_buf[16]=16;
	g_data_buf[17]=0;
	g_data_buf[18]=0;
	g_data_buf[19]=0;
	// ̧ϯė̈			(20-21)
	g_data_buf[20]=1;						// PCM
	g_data_buf[21]=0;
	// ِ̈			(22-23)
	g_data_buf[22]=1;						// 
	g_data_buf[23]=0;
	// ̎摬ẍ			(24-27) - 8000kHz
	g_data_buf[24]=((8000L)>> 0)&0xFF;
	g_data_buf[25]=((8000L)>> 8)&0xFF;
	g_data_buf[26]=((8000L)>>16)&0xFF;
	g_data_buf[27]=((8000L)>>24)&0xFF;
	// ޲đẍ			(28-31)
	g_data_buf[28]=((8000L*1*16/8)>> 0)&0xFF;
	g_data_buf[29]=((8000L*1*16/8)>> 8)&0xFF;
	g_data_buf[30]=((8000L*1*16/8)>>16)&0xFF;
	g_data_buf[31]=((8000L*1*16/8)>>24)&0xFF;
	// 򐮗̈			(32-33)
	g_data_buf[32]=((1*16/8)>>0)&0xFF;
	g_data_buf[33]=((1*16/8)>>8)&0xFF;
	// ޯĐ/̎̈		(34-35)
	g_data_buf[34]=16;						// 16ޯ
	g_data_buf[35]=0;
	// ݸ2ID̈		(36-39)
	g_data_buf[36]='d';
	g_data_buf[37]='a';
	g_data_buf[38]='t';
	g_data_buf[39]='a';
	// ݸ2eʗ̈		(40-43) - L^~ɍXV

	// ްɏՕʒuXV
	g_u16_buf_pos_wr = 44;
}

//! @brief OWAV擪ٍ̧XV
//!
//! @return	ُ̏ꍇFALSE
//!
Bool datalogging_file_update_wav_header(void)
{
	U32   u32_data;
	if( !file_seek( 4 , FS_SEEK_SET ) )
		return FALSE;
	u32_data = nav_file_lgt() -8;
	file_putc( LSB0(u32_data) );
	file_putc( LSB1(u32_data) );
	file_putc( LSB2(u32_data) );
	file_putc( LSB3(u32_data) );
	if( !file_seek( 40 , FS_SEEK_SET ) )
		return FALSE;
	u32_data -= (44-8);
	file_putc( LSB0(u32_data) );
	file_putc( LSB1(u32_data) );
	file_putc( LSB2(u32_data) );
	file_putc( LSB3(u32_data) );
	return TRUE;
}
#endif

#ifdef LOG_ENUM_EXAMPLE
U16 gu16 = 0;
#endif

//! @brief /0rv荞ݏٰ
//!
//! ADC̎(ϲ̫݂܂͑֊O)擾ĂɏՕɐݒ
//!
#ifdef __GNUC__
 ISR(TIMER0_COMPA_vect)
#else
#pragma vector = TIMER0_COMPA_vect
__interrupt void timer0_comp_interrupt()
#endif
{
#ifdef LOG_ENUM_EXAMPLE
	gu16++;
#endif

	// Ǘ
	if( g_b_buf_full[g_u8_cur_buf_wr] )
	{
		Led2_on();							// 
		return;								// oAްi[ȂB
	}else{
		Led2_off();							// OK
	}

#ifdef LOG_ADCMIC_EXAMPLE
	{
		U16 sample;
		// ϲ̫݂V̎擾
		sample = (64*Get_adc_mic_val())-0x8000;
		// ɏՕް
		g_data_buf[g_u16_buf_pos_wr]=LSB(sample);
		g_u16_buf_pos_wr++;
		g_data_buf[g_u16_buf_pos_wr]=MSB(sample);
		g_u16_buf_pos_wr++;
	}
#endif

#ifdef LOG_ADCEXT_EXAMPLE
	{
		U16 sample;
		// OV̎擾
		sample = (64*datalogging_get_adc_ext_val())-0x8000;
		// ɏՕް
		g_data_buf[g_u16_buf_pos_wr]=LSB(sample);
		g_u16_buf_pos_wr++;
		g_data_buf[g_u16_buf_pos_wr]=MSB(sample);
		g_u16_buf_pos_wr++;
	}
#endif

#ifdef LOG_PIN_EXAMPLE
	// ɏՕް
	g_data_buf[g_u16_buf_pos_wr] = Is_joy_down()? 0xFF : 0x00;
	g_u16_buf_pos_wr++;
#endif

#ifdef LOG_ENUM_EXAMPLE
	g_data_buf[g_u16_buf_pos_wr]=LSB(gu16);
	g_u16_buf_pos_wr++;
	g_data_buf[g_u16_buf_pos_wr]=MSB(gu16);
	g_u16_buf_pos_wr++;
#endif

	if( 0 == (g_u16_buf_pos_wr%FS_SIZE_OF_SECTOR) )
	{
		g_b_buf_full[g_u8_cur_buf_wr] = TRUE;
		if( DATA_BUF_SIZE == g_u16_buf_pos_wr )
		{
			g_u16_buf_pos_wr = 0;
			g_u8_cur_buf_wr  = 0;
		}else{
			g_u8_cur_buf_wr++;
		}
	}
}

#ifdef LOG_ADCEXT_EXAMPLE
//! @brief ۸ 13擾ٰ(ADC)
//!
//! @note	gp҂(STK527J47݂ŗp\)󂢂ĂPB6͂ɑ݂M𑗐M悤ɑIԂƂł܂B
//!			͊O킩PB6ő鏃Ȑg爽鑪ŝɎgp邱Ƃł܂B
//!
U16 datalogging_get_adc_ext_val(void)
{
	Start_conv_channel(0x25);
	while (!Is_adc_conv_finished());
	return (U16)(ADCL+((U16)(ADCH<<8)));
}
#endif
